config/routes.rb
Rails.application.routes.draw do


  devise_for :developers


  root 'estates#index'

  resources :developers do
    resources :estates
  end


  get 'question/search', to: 'customer#search', as: 'search'
  post 'question/find', to: 'customer#find', as: 'find'
  get 'question/find', to: 'customer#find', as: 'find_get'
  get 'sort', to: 'customer#sort_by', as: 'sort_by'
  post 'sort', to: 'customer#sort', as: 'sort'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/developer.rb
class Developer < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
  has_many :estates
end

app/models/estate.rb
class Estate < ApplicationRecord


  validates :estate_type, :surface, :room, :bathroom, :price, :city , :street, presence: true
  validates_numericality_of :room, :bathroom, :only_integer => true, :message => "can only be whole number.", :allow_nil => true
  validates_numericality_of :surface, :price, :only_float => true, :message => "can only be whole number.", :allow_nil => true


  belongs_to :developer

  geocoded_by :full_address
  after_validation :geocode

  def full_address
    [city,street].compact.join(',')
  end





  has_attached_file :picture, styles: { medium: "300x300>", thumb: "100x100>" }
  validates_attachment_content_type :picture, content_type: /\Aimage\/.*\z/
end

app/controllers/admin_controller.rb
class AdminController < ApplicationController
  def index

  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :configure_permitted_parameters, if: :devise_controller?

  layout :set_layout
  def set_layout
    if current_developer
      'developer'
    else
      'estate'
    end
  end
protected
  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:company, :name, :phone_nr])
  end
  private
  def after_sign_in_path_for(current_developer)
    new_developer_estate_path(:developer_id => current_developer.id)
  end
end

app/controllers/customer_controller.rb
class CustomerController < ApplicationController


  def search

  end

  def find
    @developer=params[:developer]
    if !@developer
      @developer=current_developer.company
    end
    @estates=Estate.joins(:developer).where('developers.company=?', @developer)
    @estates=@estates.where('estate_type =?', params[:estate_type]) if params[:estate_type].present?

    @estates=@estates.where('surface>= ?', params[:surface_from]) if params[:surface_from].present?
    @estates=@estates.where('surface<= ?', params[:surface_to]) if params[:surface_to].present?
    @estates=@estates.where('room>= ?', params[:room_min]) if params[:room_min].present?
    @estates=@estates.where('room<= ?', params[:room_max]) if params[:room_max].present?
    @estates=@estates.where('city=?', params[:city]) if params[:city].present?
    if params[:garage].present?
      @garage=true
      @estates=@estates.where('garage=?', @garage)
    end

    @estates=@estates.order(params[:sort]) if params[:sort].present?

    @estates_localization=@estates
    @hash=Gmaps4rails.build_markers(@estates_localization) do |place, marker|
      marker.lat place.latitude
      marker.lng place.longitude
    end


  end



end

app/controllers/developers_controller.rb
class DevelopersController < ApplicationController





  def index
    @developers=Developer.all
  end


  def edit
    @developer=Developer.find(params[:id])
  end


  def update
    @developer=Developer.find(params[:id])
     if @developer.update(dev_params)
      redirect_to root_url
     else
       render 'edit'
       end

  end



  private
  def dev_params
    params.require(:developer).permit(:company, :name, :phone_nr)
  end



end

app/controllers/estates_controller.rb
class EstatesController < ApplicationController

  def index


    @estates = Estate

    if params[:sort].present?
      result_table=['developers.company', 'price', 'surface']
      if result_table.include?(params[:sort])
        @estates=@estates.joins(:developer).order(params[:sort])
      end

    end
    @estates = @estates.all
    @hash=Gmaps4rails.build_markers(@estates) do |place, marker|
      marker.lat place.latitude
      marker.lng place.longitude
    end

  end


  def new
    @developer=Developer.find_by(:id => current_developer.id)
    @estate=@developer.estates.build;

  end

  def create
    @developer=Developer.find_by(:id => current_developer.id)
    @estate=@developer.estates.create(estate_params)

    if @estate.save
      redirect_to root_url
    else
      render 'new'
    end

  end

  def edit
    @developer=Developer.find_by(:id => params[:developer_id])
    @estate=@developer.estates.find(params[:id])
  end

  def update
    @developer=Developer.find_by(:id => params[:developer_id])
    @estate=@developer.estates.find(params[:id])
    @estate.update(estate_params)
    redirect_to root_url
  end


  private
  def estate_params
    params.require(:estate).permit(:estate_type, :surface, :room, :bathroom, :garage, :city, :street, :price, :picture)
  end


  def correct_developer
    @developer=current_developer.estates.find_by(:id => params[:id])
    redirect_to developer_estates_path if @developer.nil?
  end
end

app/helpers/admin_helper.rb
module AdminHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/customer_helper.rb
module CustomerHelper
end

app/helpers/developers_helper.rb
module DevelopersHelper
end

app/helpers/estates_helper.rb
module EstatesHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/views/customer/find.html.erb
<script src="//maps.google.com/maps/api/js?key=AIzaSyCV9GPNnjd8_soBPB1vPJsR-j6Yk9BTqLw"></script>
<script src="//cdn.rawgit.com/mahnunchik/markerclustererplus/master/dist/markerclusterer.min.js"></script>
<script src='//cdn.rawgit.com/printercu/google-maps-utility-library-v3-read-only/master/infobox/src/infobox_packed.js' type='text/javascript'></script> <!-- only if you need custom infoboxes -->

Sort by: <%= form_tag root_path, method: :get, :id => 'sort_form_tag' do %>
    <%= select_tag :sort, options_for_select([['',''],['Developer', 'developers.company'], ['Price', 'price'], ['Surface', 'surface']]), :id => 'sort_select' %>

<% end %>

<% @estates.each do |estate| %>
<p><%=estate.developer.name  %><br>
    <%= estate.estate_type %><br>
    <%= estate.surface %><br>

<%= estate.price %><br>
  <%= estate.city %><br>
  <%= image_tag estate.picture.url(:medium) %></p>
<% end %>



<div style='width: 800px;'>
  <div id="map" style='width: 800px; height: 400px;'></div>
</div>

<script>

    handler = Gmaps.build('Google');
    handler.buildMap({ provider: {}, internal: {id: 'map'}}, function(){
        markers = handler.addMarkers(<%= raw @hash.to_json %>);
        handler.bounds.extendWith(markers);
        handler.fitMapToBounds();
    });
</script>


<%= link_to 'Home', root_url %>

app/views/developers/_form.html.erb
<%= form_for @developer do |d| %>
    <%= d.label :company %>
    <%= d.text_field :company%><br>
    <%= d.label :name %>
    <%= d.text_field :name %><br>
    <%= d.label :phone_nr %>
    <%= d.text_field :phone_nr %><br>
    <% if @developer.errors.any? %>

        <% @developer.errors.full_messages.each do |msg| %>
            <ul>
              <li> <%= msg %> </li>
            </ul>
        <% end %>

    <% end %>
    <%= d.submit 'zapisz' %>
<% end %>

app/views/developers/edit.html.erb
<%= render :partial => 'form' %>
<%= link_to 'Back', :back %>

app/views/developers/index.html.erb
<% @developers.each do |developer| %>
    <p>
<%= developer.company %><br>
<%= developer.name %><br>
<%= developer.phone_nr %><br>
<%= developer.estate_id %><br>
      <% if current_developer.company ==developer.company%>
      <%= link_to 'dodaj nieruchomosc', new_developer_estate_path(:developer_id => developer.id) %>

          <% end %></p>
<% end %>

app/views/estates/_form.html.erb
<%= form_for [@developer,@estate] do |e| %>


    <%= e.label :estate_type %>
    <%= e.select :estate_type, options_for_select([['House' ,'house',],['Flat','flat']],@estate.estate_type) %><br>
    <%= e.label :surface %>
    <%= e.text_field :surface %><br>
    <%= e.label :room %>
    <%= e.text_field :room %><br>
    <%= e.label :bathroom %>
    <%= e.text_field :bathroom %><br>
    <%= e.label :garage %>
    <%= e.check_box :garage %><br>
    <%= e.label :city %>
    <%= e.text_field :city %><br>
    <%= e.label :street %>
    <%= e.text_field :street %><br>
    <%= e.label :price %>
    <%= e.text_field :price %><br>
    <%= e.label :picture %>
    <%= e.file_field :picture %><br>

    <% if @estate.errors.any? %>

        <% @estate.errors.full_messages.each do |msg| %>
            <ul>
              <li> <%= msg %> </li>
            </ul>
        <% end %>

    <% end %>
    <%= e.submit 'zapisz' %>
<% end %>

app/views/estates/edit.html.erb
<%= render :partial=>'form' %>
<%=link_to 'back', :back  %>

app/views/estates/index.html.erb
<script src="//maps.google.com/maps/api/js?key=AIzaSyCV9GPNnjd8_soBPB1vPJsR-j6Yk9BTqLw"></script>
<script src="//cdn.rawgit.com/mahnunchik/markerclustererplus/master/dist/markerclusterer.min.js"></script>
<script src='//cdn.rawgit.com/printercu/google-maps-utility-library-v3-read-only/master/infobox/src/infobox_packed.js' type='text/javascript'></script> <!-- only if you need custom infoboxes -->
<th>Sort by: <%= form_tag root_path, method: :get, :id => 'sort_form_tag' do %>
      <%= select_tag :sort, options_for_select([['',''],['Developer', 'developers.company'], ['Price', 'price'], ['Surface', 'surface']]), :id => 'sort_select' %>

  <% end %>



<% @estates.each do |estate| %>
    <p><%= image_tag estate.picture.url(:medium) %></p>
    <p>Developer: <%= estate.developer.company %> </p>
    <p>Estate type: <%= estate.estate_type %></p>
    <p>Surface: <%= estate.surface %></p>
    <p>Price: <%= estate.price %></p>
  <p>Garage:  <% if estate.garage %>
        <%= "yes" %>
    <% else %>
        <%= "no" %>
    <% end %><br>
    <p>City: <%= estate.city %> </p><br>
      <% if current_developer %>
    <%= link_to 'Edit', edit_developer_estate_path(estate.developer.id, estate.id) %>
          <% end %>
<% end %>


<div style='width: 800px;'>
  <div id="map" style='width: 800px; height: 400px;'></div>
</div>

<script type="text/javascript">

    handler = Gmaps.build('Google');
    handler.buildMap({ provider: {}, internal: {id: 'map'}}, function(){
        markers = handler.addMarkers(<%= raw @hash.to_json %>);
        handler.bounds.extendWith(markers);
        handler.fitMapToBounds();
    });
</script>

<% if current_developer %>
<%= link_to 'new estate', new_developer_estate_path(current_developer.id) %>
<% end %>

app/views/estates/new.html.erb
<%= render :partial=>'form' %>

<%= link_to 'Back', :back %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Tecnocasa</title>

  </head>

  <body>
  <p class="notice"><%= notice %></p>
  <p class="alert"><%= alert %></p>
    <%= yield %>
  </body>
</html>

app/views/layouts/developer.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Tecnocasa</title>
  <%= csrf_meta_tags %>

  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>


</head>

<body>


<table>
  <tr>
    <th>
      <% if current_developer %>
          <%= "You are loged in as: #{current_developer.company}" %><br>
          <%= link_to 'Log out', destroy_developer_session_path , method: :delete%><br>
      <% else %>
          <%= link_to 'Log in', new_developer_session_path %>
      <% end %>
      Search:
    </th>
    <th>
      <p><%= link_to "Edit profile", edit_developer_path(:id => current_developer.id) %>
      <%= link_to 'Add estate', new_developer_estate_path(:developer_id => current_developer.id) %></p>
      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>
    </th>
  </tr>
  <tr>
    <td>
      <%= form_tag find_path, id: 'search_form' do %>

          <p>Estate type:<br>
            <%= select_tag :estate_type, options_for_select([['-',''],['House', 'house'], ['Flat', 'flat']], params[:estate_type]) %>
          </p>
          <p>Surface:<br>
            From:<%= text_field_tag :surface_from, params[:surface_from] %><br>
            To:<%= text_field_tag :surface_to, params[:surface_to] %></p>
          <p>Rooms:<br>
            Min:<%= text_field_tag :room_min, params[:room_min] %><br>
            Max:<%= text_field_tag :room_max, params[:room_max] %></p>

          <p>Garage:<br>
            <%= check_box_tag :garage %>
          </p>
          <p>City:<br>
            <%= text_field_tag :city, params[:city] %>
          </p>
          <p>Street:<br>
            <%= text_field_tag :street, params[:street] %>
          </p>
          <p> Sort by: <br>
          <%= select_tag :sort, options_for_select([['',''], ['Price', 'price'], ['Surface', 'surface']]) %>
          </p>

          <p><%= submit_tag "Search" %>
          </p>
      <% end %>

    </td>
    <td><%= yield %></td>
  </tr>


</table>

</body>

</html>

app/views/layouts/estate.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Estates</title>
  <%= csrf_meta_tags %>

  <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>


</head>

<body>


<table>
  <tr>
    <th>

      <%= link_to 'Log in', new_developer_session_path %>


    </th>
    <th>
      <p class="notice"><%= notice %></p>
      <p class="alert"><%= alert %></p>
    </th>
  </tr>
  <tr>
    <td>
      Search:<br>
      <%= form_tag find_path, id: 'search_form' do %>
          <p>Developer:<br>
            <%= select_tag :developer, options_for_select([['Emerson', 'Emerson',], ['Budimex', 'Budimex']], @developer) %>
          </p>
          <p>Estate type::<br>
            <%= select_tag :estate_type, options_for_select([['House', 'house',], ['Flat', 'flat']], params[:estate_type]) %>
          </p>
          <p>Surface:<br>
            From:<%= text_field_tag :surface_from, params[:surface_from] %><br>
            To:<%= text_field_tag :surface_to, params[:surface_to] %></p>
          <p>Rooms:<br>
            Min:<%= text_field_tag :room_min, params[:room_min] %><br>
            Max:<%= text_field_tag :room_max, params[:room_max] %></p>

          <p>Garage:<br>
            <%= check_box_tag :garage, params[:garage] %>
          </p>
          <p>City:<br>
            <%= text_field_tag :city, params[:city] %>
          </p>
          <p>Street:<br>
            <%= text_field_tag :street, params[:street] %>
          </p>
          <p> Sort by: <br>
            <%= select_tag :sort, options_for_select([['',''],['Developer', 'developers.company'], ['Price', 'price'], ['Surface', 'surface']]) %>
          </p>



          <p><%= submit_tag "Search" %>
          </p>
      <% end %>

    </td>
    <td><%= yield %></td>
  </tr>


</table>

</body>

</html>